/* 
   C support code for connection.pl 
   
   (C) Sandiway Fong, November 26th 2000. NEC Research Institute, Inc.

   Updated:

   Sandiway Fong, October 27th 2003. University of Arizona

*/

/* Size of Wordnet 1.7 is 111223 synsets */
#define SIZE 111224

int mark[SIZE];

void reset_mark() {
  int i;

  for(i=0; i<SIZE; i++) 
    mark[i] = 0;
}

void set_mark(i, v) 
     int i, v; 
{
  mark[i] = v;
}

int get_mark(i) 
     int i;
{
  return( mark[i] );
}

int count_marks()
{
  int i;
  int total = 0;

  for(i=0; i<SIZE; i++)
    if( mark[i] > 0) total++;

  return( total );
}

/* Path Tree */

#define PTSIZE 8000000		/* 8,000,000 * 4 bytes = 32Mb */
#define MARK  -2147483648     /* -2^31, old mar was 2^30 1073741824 */

int pt[PTSIZE];
int ptr  = 0;
int rptr = 0;			/* report ptr */
int zptr = 0;			/* zip ptr, used for expansion */
int sep  = 0;			/* last known location of the mark */
int sep2 = 0;			/* last known location of the previous mark */

void reset_pt()
{
  int i;

  pt[0] = MARK;

  for(i=1; i<PTSIZE; i++) 
    pt[i] = 0;

  ptr  = 1;
  sep  = 0;
  sep2 = 0;
}

void add_pt(v, p)
     int v, p;
{
  if( ptr > (PTSIZE - 2)) {
    printf("\n Error: Path Tree overrun!\n");
    exit(2);
  }
  pt[ptr++] = p;
  pt[ptr++] = v;
}

void add_sep()
{
  sep2 = sep;
  sep = ptr;
  pt[ptr++] = MARK;
}

void zip_pt()			/* move back two marks */
{
  zptr = sep2;
}
  
int at_pt()
{
  if( pt[++zptr] == MARK ) {
    return( 0 );
  }
  else {
    return( pt[++zptr] );	/* nb. two in front */
  }
}

int at2_pt()
{
  return( zptr );
}

int bk_pt( i )			/* back pointer value */
     int i;
{
  return( pt[i] );
}

int bk2_pt( i )			/* 2nd value is the next back pointer */
     int i;
{ 
  return( pt[i-1] );
}

void print_pt() 
{
  int i;

  for( i=0; i<ptr; i++)
    if( pt[i] == MARK ) {
      printf(" $ ");
    }
    else {
      printf(" %d",pt[i]);
    }

  printf(" (%d)\n",ptr);
}

      
	
     
